# remirepo/Fedora spec file for php-zendframework-zend-serializer
#
# Copyright (c) 2015-2019 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    6fb7ae016cfdf0cfcdfa2b989e6a65f351170e21
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-serializer
%global php_home     %{_datadir}/php
%global library      Serializer
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.9.1
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-dom
BuildRequires:  php-libxml
BuildRequires:  php-pcre
BuildRequires:  php-simplexml
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.14 || ^7.5.16",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-math": "^2.6 || ^3.0",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3"
BuildRequires: (php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7    with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-json)           >= 2.5    with php-autoloader(%{gh_owner}/zend-json)           < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-math)           >= 2.6    with php-autoloader(%{gh_owner}/zend-math)           < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.5  with php-autoloader(%{gh_owner}/zend-servicemanager) < 4)
BuildRequires:  phpunit7 >= 7.5.16
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-json": "^2.5 || ^3.0"
#        "zendframework/zend-stdlib": "^2.7 || ^3.0",
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
Requires:      (php-autoloader(%{gh_owner}/zend-json)             >= 2.5    with php-autoloader(%{gh_owner}/zend-json)             < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)           >= 2.7    with php-autoloader(%{gh_owner}/zend-stdlib)           < 4)
# From composer, "suggest": {
#        "zendframework/zend-math": "(^2.6 || ^3.0) To support Python Pickle serialization",
#        "zendframework/zend-servicemanager": "(^2.7.5 || ^3.0.3) To support plugin manager support"
Suggests:       php-composer(%{gh_owner}/zend-math)
Suggests:       php-composer(%{gh_owner}/zend-servicemanager)
Suggests:       php-pecl(igbinary)
Suggests:       php-pecl(msgpack)
%endif
# From phpcompatinfo report for version 2.5.1
Requires:       php-dom
Requires:       php-libxml
Requires:       php-pcre
Requires:       php-simplexml
Requires:       php-spl
# Autoloader
Requires:       php-composer(fedora/autoloader)

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
The Zend\Serializer component provides an adapter based interface
to simply generate storable representation of PHP types by different
facilities, and recover.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Stdlib/autoload.php',
    '%{php_home}/Zend/Json/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Math/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmd in php php71 php72 php73 php74; do
  if which $cmd; then
    $cmd %{_bindir}/phpunit7 --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Mon Oct 21 2019 Remi Collet <remi@remirepo.net> - 2.9.1-1
- update to 2.9.1 (no change)
- switch to phpunit7

* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.9.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.9.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.9.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Tue May 15 2018 Remi Collet <remi@remirepo.net> - 2.9.0-2
- update to 2.9.0
- use range dependencies
- switch to phpunit6

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Nov 23 2017 Remi Collet <remi@remirepo.net> - 2.8.1-2
- switch from zend-loader to fedora/autoloader

* Tue Nov 21 2017 Remi Collet <remi@remirepo.net> - 2.8.1-1
- Update to 2.8.1

* Thu Nov  9 2017 Remi Collet <remi@fedoraproject.org> - 2.8.0-4
- fix FTBFS from Koschei, add patch for bigendian from
  https://github.com/zendframework/zend-serializer/pull/31

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Jun 21 2016 Remi Collet <remi@fedoraproject.org> - 2.8.0-1
- update to 2.8.0
- raise dependency on PHP 5.6

* Wed May 11 2016 Remi Collet <remi@fedoraproject.org> - 2.7.2-1
- update to 2.7.2
- dependency to zend-math is now optional

* Tue Apr 19 2016 Remi Collet <remi@fedoraproject.org> - 2.7.1-1
- update to 2.7.1

* Thu Apr  7 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- update to 2.7.0

* Mon Feb  8 2016 Remi Collet <remi@fedoraproject.org> - 2.6.1-1
- update to 2.6.1

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Oct  1 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- normal build

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-0
- initial package, bootstrap build
